%define aurox_ver 10.0
%define rel 1


# no smp releases: does not work with spm kernels
%define kversion 2.6.7
#%define krelease 1.2174.nptl
# Live 1.4.2:
#define krelease 1.2149.nptl
# Live + CCRMA:
#%define krelease 1.2188.nptl.caps.rhfc1.ccrma
%define krelver 10.0.aur.9
%define DRV_VERSION 2.9.9

%define kernel %{kversion}-%{krelver}

%define _libmoddir /lib/modules
%define moduledir /kernel/drivers/char/slmdm

Summary: Linux Smartlink Linmodem drivers.
Name: slmodem
Version: %{DRV_VERSION}
Release: %{aurox_ver}.aur.%{rel}
License: Distributable
Group: System Environment/Base
URL: http://linmodems.technion.ac.il/packages/smartlink/
Source: ftp://ftp.smlink.com/linux/unsupported/slmodem-%{version}.tar.gz
Patch0: slmodem-2.9.6-makemodule.patch
Patch1: slmodem-2.9.9-modprobe.patch
BuildRoot: %{_tmppath}/root-%{name}-%{version}
Prefix: %{_prefix}


%description
Linux Smartlink Linmodem drivers.

HW drivers for:
  + HAMR5600 based AMR/CNR/MDC/ACR modem cards
  + SmartPCI56, SmartPCI561 based PCI modem cards
  + SmartUSB56 based USB modem

%package kernel-%{kernel}
Summary: Linux Smartlink Linmodem drivers.
Group: System Environment/Kernel
BuildRequires: kernel-source, pciutils, gcc32
Release: %{release}
Requires: kernel = %{kernel}
Requires: slmodem-utils = %{DRV_VERSION}
Obsoletes: kernel-module-slmdm, kernel-module-slmodem
Provides: kernel-modules

%description kernel-%{kernel}
Linux Smartlink Linmodem drivers.
#
HW drivers for:
  + HAMR5600 based AMR/CNR/MDC/ACR modem cards
  + SmartPCI56, SmartPCI561 based PCI modem cards
  + SmartUSB56 based USB modem

%package utils
Summary: Linux Smartlink Linmodem utilities.
Group: System Environment/Base
Obsoletes: slmodem, slmdm, slmdm-utils
Provides: slmodem, slmdm, slmdm-utils

%description utils
Linux Smartlink Linmodem utilities.

%prep
rm -rf %{_tmppath}/linux-%{kversion}-%{krelver} 2>/dev/null

%setup -n %{name}-%{version}
%patch0 -p1 -b .makemodule
%patch1 -p1 -b .modprobe

%build
rm -rf %{buildroot}
export KERNEL_VER=%{kernel}

BuildModule() {
        if [ -n "$1" ]; then
                Config=/usr/src/linux-%{kversion}-%{krelver}/configs/kernel-%{kversion}-%{_target_cpu}-$1.config
        else
%ifarch i386
# Since we only build userspace in this pass, the actual .config doesn't matter
                Config=/usr/src/linux-%{kversion}-%{krelver}/configs/kernel-%{kversion}-i686.config
%else
                Config=/usr/src/linux-%{kversion}-%{krelver}/configs/kernel-%{kversion}-%{_target_cpu}.config
%endif
        fi
        cp -f $Config %{_tmppath}/linux-%{kversion}-%{krelver}/.config
        # Make sure version matches
        perl -p -i -e "s/^EXTRAVERSION.*/EXTRAVERSION = -%{krelver}$1/" %{_tmppath}/linux-%{kversion}-%{krelver}/Makefile
        make -C %{_tmppath}/linux-%{kversion}-%{krelver} nonint_oldconfig 1>/dev/null
        make -C %{_tmppath}/linux-%{kversion}-%{krelver} prepare-all
        make KERNEL_DIR=%{_tmppath}/linux-%{kversion}-%{krelver}
}
# This is absolutely wrong, change to cp -af if it doesn't work
cp -alf /usr/src/linux-%{kversion}-%{krelver} %{_tmppath}
BuildModule

#make CC=gcc32 KERNEL_DIR=/usr/src/linux-%{kernel} KERNEL_INCLUDES=/usr/src/linux-%{kernel}/include MODULE_CFLAGS="-D__BOOT_KERNEL_H_ -D__MODULE_KERNEL_%{_target_cpu}=1 -D__BOOT_KERNEL_UP=1"


%install
mkdir -p %{buildroot}%{_libmoddir}/%{kernel}%{moduledir}/
install -m 0744 drivers/slamr.ko %{buildroot}%{_libmoddir}/%{kernel}%{moduledir}/
install -m 0744 drivers/slusb.ko %{buildroot}%{_libmoddir}/%{kernel}%{moduledir}/
mkdir -p %{buildroot}%{_sbindir}/
install -m 0755 modem/slmodemd %{buildroot}%{_sbindir}/
mkdir -p %{buildroot}%{_sysconfdir}/rc.d/init.d/
install -m 0755 scripts/slmodemd %{buildroot}%{_sysconfdir}/rc.d/init.d/

%post
/sbin/chkconfig --add slmodemd
/sbin/service slmodemd condrestart

%preun
if [ $1 = 0 ]; then
        /sbin/service slmodemd stop > /dev/null 2>&1
        /sbin/chkconfig --del slmodemd
fi


%post kernel-%{kernel}
#for i in 0 1 2 3; do
#	rm -f /dev/slamr$i /dev/slusb$i
#	mknod -m660 /dev/slamr$i c 212 $i
#	mknod -m660 /dev/slusb$i c 213 $i
#	chown root:uucp /dev/slamr$i /dev/slusb$i
#done
#cp /etc/modules.conf /etc/modules.conf.slamr && \
#egrep -ve 'alias char-major-212 slamr|alias char-major-213 slusb' /etc/modules.conf.slamr > /etc/modules.conf && \
#echo 'alias char-major-212 slamr' >> /etc/modules.conf && \
#echo 'alias char-major-213 slusb' >> /etc/modules.conf
/sbin/depmod -ae %{kernel} || :
 
%postun kernel-%{kernel}
/sbin/depmod -ae %{kernel} || :
#cp /etc/modules.conf /etc/modules.conf.slamr && \
#   egrep -ve 'alias char-major-212 slamr|alias char-major-213 slusb' /etc/modules.conf.slamr > /etc/modules.conf

%clean
rm -rf %{buildroot}
rm -rf %{_tmppath}/linux-%{kversion}-%{krelver}

%ifarch i386
%files utils
%undefine __check_files
%defattr(-, root, root, 0755)
%doc Changes README*
%{_sbindir}/*
%{_sysconfdir}/rc.d/init.d/*
%else
%files kernel-%{kernel}
%undefine __check_files
%defattr(-, root, root, 0755)
%{_libmoddir}/%{kernel}%{moduledir}/
%endif

%changelog
* Fri Aug 13 2004 Aurox Team <aurox@aurox.org> 0:2.9.9-10.0.aur.1
- Update slmodemd service to load modules.
- Upgrade to 2.9.9, fix build process.
- build for Aurox Live
- add extra flags when building modules
- build with new kernel
- change requirements: let utils require kernel module, not the other way
- initail import

* Fri Feb 20 2004 Dag Wieers <dag@wieers.com> - 2.9.6-0
- Updated to release 2.9.6.

* Mon Feb 09 2004 Dag Wieers <dag@wieers.com> - 2.9.5-0
- Updated to release 2.9.5.

* Thu Jan 01 2004 Dag Wieers <dag@wieers.com> - 2.9.4-0
- Renamed base-package to kernel-module-slmodem.

* Tue Dec 09 2003 Dag Wieers <dag@wieers.com> - 2.9.3-0
- Updated to release 2.9.3.

* Mon Dec 01 2003 Dag Wieers <dag@wieers.com> - 2.9.2-0
- Updated to release 2.9.2.

* Sun Jul 20 2003 Dag Wieers <dag@wieers.com> - 2.7.10-0
- Fixed the problem with 2.7.14.
- Renamed slmdm to slmdm-utils.

* Sun Jul 20 2003 Dag Wieers <dag@wieers.com> - 2.7.14-0
- Initial package. (using DAR)
